/* -*- c++ -*- */

//=============================================================================
/**
 *  @file    be_module.h
 *
 *  $Id: be_module.h 89076 2010-02-18 22:54:36Z parsons $
 *
 *  Extension of class AST_Module that provides additional means for C++
 *  mapping.
 *
 *
 *  @author Copyright 1994-1995 by Sun Microsystems
 *  @author Inc. and Aniruddha Gokhale
 */
//=============================================================================

#ifndef _BE_MODULE_H
#define _BE_MODULE_H

#include "be_scope.h"
#include "be_decl.h"
#include "ast_module.h"

class be_visitor;

class be_module : public virtual AST_Module,
                  public virtual be_scope,
                  public virtual be_decl
{
public:
  be_module (UTL_ScopedName *n);

  /// Cleanup method.
  virtual void destroy (void);

  // Visiting
  virtual int accept (be_visitor *visitor);

  // Narrowing.
  DEF_NARROW_FROM_DECL (be_module);
  DEF_NARROW_FROM_SCOPE (be_module);
};

#endif
