/* -*- c++ -*- */

//=============================================================================
/**
 *  @file    root_cnh.h
 *
 *  $Id: root_cnh.h 88919 2010-02-09 22:55:55Z parsons $
 *
 *  Concrete visitor for the Root class
 *  This one provides code generation for elements of the Root node in the
 *  CIAO connector impl header.
 *
 *
 *  @author Jeff Parsons
 */
//=============================================================================


#ifndef _BE_VISITOR_ROOT_ROOT_CNH_H_
#define _BE_VISITOR_ROOT_ROOT_CNH_H_

/**
 * @class be_visitor_root_cnh
 *
 * @brief be_visitor_root_cnh
 *
 * This is a concrete visitor to generate the CIAO connector
 * header for root
 */
class be_visitor_root_cnh : public be_visitor_root
{
public:
  be_visitor_root_cnh (be_visitor_context *ctx);

  ~be_visitor_root_cnh (void);

  /// Set the right context and make a visitor.
  virtual int init (void);
};

#endif /* _BE_VISITOR_ROOT_ROOT_CNH_H_ */
